<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Homepage extends Frontend_Controller{
	protected $_trash = false;
	
	function __construct(){
		parent::__construct();
		$this->breadcrumbs_arr[] = array("title"=>"الرئيسية");	
	}	
	public function index(){
		$site_name = config_item("frontend_title");
        $this->data["page_title"] = $site_name." - "._lang("Home");		
		$this->data["is_home"] = true;

		$this->load->model("profs_m");
		$this->profs_m->limit = 9;
		$this->db->where("profs_status",1);	
		$this->db->where("profs_vip",1);			
		$profs = $this->profs_m->get("",false,true,false,"",true);

		$this->load->model("category_m");
		$parent_categories = $this->category_m->get('',false,true,$this->_trash,"",true);
		$categories_options = array();
		foreach($parent_categories as $_parent_category){
			$categories_options[$_parent_category->cat_id] = $_parent_category->cat_name;
		}
		unset($parent_categories);unset($_parent_category);
		$this->data["categories_options"] = $categories_options;
		//
		$this->load->model("city_m");
		$parent_cities = $this->city_m->get('',false,true,$this->_trash,"",true);
		$cities_options = array();
		foreach($parent_cities as $_parent_city){
			$cities_options[$_parent_city->city_id] = $_parent_city->city_name;
		}
		unset($parent_cities);unset($_parent_city);
		$this->data["cities_options"] = $cities_options;

		foreach($profs as $_object){			
			$cat_id_field = "profs_cat_id";
			if(!empty($_object->$cat_id_field) && !empty($categories_options[$_object->$cat_id_field])){
				$_object->cat_name = $categories_options[$_object->$cat_id_field];
			}else{
				$_object->cat_name = " بدون قسم ";
			}
			$city_id_field = "profs_city_id";
			if(!empty($_object->$city_id_field) && !empty($cities_options[$_object->$city_id_field])){
				$_object->city_name = $cities_options[$_object->$city_id_field];
			}else{
				$_object->city_name = " بدون مدينة ";
			}			
		}

		$this->data["profs"] = $profs;

		$this->load_template_view("homepage",$this->data);
	}
}