<?php
function radio_get_request($request_id){
	$CI = get_instance();
	$CI->load->model("request_m");
	return $CI->request_m->get($request_id);
}

function radio_mail_patient_data($data){
	return '<table>
		<tr>
			<td>'._lang("Login name").'</td><td>'._t($data['user_name']).'</td>
		</tr>
		<tr>
			<td>'._lang("Patient name").'</td><td>'._t($data['user_nickname']).'</td>
		</tr>
		<tr>
			<td>'._lang("Patient email").'</td><td>'._t($data['user_email']).'</td>
		</tr>
		<tr>
			<td>'._lang("Patient phone").'</td><td>'._t($data['patient_phone']).'</td>
		</tr>
		<tr>
			<td>'._lang("Birth year").'</td><td>'._t($data['patient_birthdate']).'</td>
		</tr>
		<tr>
			<td>'._lang("Gender").'</td><td>'._t($data['patient_gender']).'</td>
		</tr>
	</table>';
}

function radio_mail_request_data($request){
	$CI = get_instance();
	$CI->load->model("meta_m");
	$title = $CI->meta_m->get_meta($request->doctor_id,"doctor_title","doctor");
	if(!empty($title))$title = _t($title->meta_value); else $title = _lang("Dr");
	$doctor = content_by_id($request->doctor_id);
	$doctor_name = $title." / "._t($doctor->content_title);
	return '<table>
		<tr>
			<td>'._lang("Patient name").'</td><td>'._t($request->user_nickname).'</td>
		</tr>
		<tr>
			<td>'._lang("Doctor").'</td><td>'.$doctor_name.'</td>
		</tr>
		<tr>
			<td>'._lang("Case description").'</td><td>'._t($request->case_description).'</td>
		</tr>
		<tr>
			<td>'._lang("Payment method").'</td><td>'._t($request->paym_name).'</td>
		</tr>
		<tr>
			<td>'._lang("Cost").'</td><td>'._t($request->price).'</td>
		</tr>
	</table>';
}

function mail_patient_registeration($_data){
	$subject = _lang("Welcome");
	$message = _lang("You have signed up to our site");
	$message .= radio_mail_patient_data($_data);
	$message = ci_radio_mail_design($message);
	radio_send_mail($_data["user_email"],$subject,$message);
}

function mail_admin_registeration($_data){
	$_mail = ci_get_option("admin_email");
	$subject = _lang("Welcome");
	$message = _lang("A new patient has signed up to our site");
	$message .= radio_mail_patient_data($_data);
	$message = ci_radio_mail_design($message);
	radio_send_mail($_mail,$subject,$message);
}

function radio_mail_registeration($_data){
	/* pass registeration post data here */
	mail_patient_registeration($_data);
	mail_admin_registeration($_data);
}

function radio_mail_request($id){
	/* pass registeration post data here */
	mail_patient_request($id);
	mail_doctor_request($id);
	mail_admin_request($id);
}

function mail_patient_request($request_id){
	$CI = get_instance();
	$_mail = $CI->session->userdata("patient_email");
	$request = radio_get_request($request_id);
	$subject = _lang("Request sent successfully");
	$message = _lang("Yor request was sent successfully");
	$message .= radio_mail_request_data($request);
	$message = ci_radio_mail_design($message);
	radio_send_mail($_mail,$subject,$message);
}

function mail_admin_request($request_id){
	$_mail = ci_get_option("admin_email");
	$request = radio_get_request($request_id);
	$subject = "new request";
	$message = _lang("New request was sent successfully");
	$message .= radio_mail_request_data($request);
	$message = ci_radio_mail_design($message);
	radio_send_mail($_mail,$subject,$message);
}

function mail_doctor_request($request_id){
	$request = radio_get_request($request_id);
	$CI = get_instance();
	$CI->load->model("meta_m");
	$_mail = $CI->meta_m->get_meta($request->doctor_id,"doctor_email","doctor");
	if(!empty($_mail))$_mail = $_meta->meta_value;
	$subject = "new request";
	$message = _lang("New request was sent successfully");
	$message .= radio_mail_request_data($request);
	$message = ci_radio_mail_design($message);
	radio_send_mail($_mail,$subject,$message);
}

function ci_radio_mail_design($mail_content="",$rtl = false){
	$_dir = "left";if($rtl)$_dir = "right";
	$_mail = get_option("admin_email");
	$message = '<div  style="font-family:sans-serif;font-size:12px;color:#505050;margin:0;padding:0;background-color:#f9f9fa;text-align:center">
	<div style="font-family:sans-serif;font-size:12px;color:#505050;width:900px;margin:0 auto;text-align:center">
		<div style="font-family:sans-serif;font-size:20px;color:#FFF;background:#5CA5DD;height:80px;line-height:80px;padding:0px 40px;text-align:'.$_dir.';">
		TELEMIDICINE
		</div>
		<div style="font-family:sans-serif;font-size:12px;color:#505050;background:#f9f9fa repeat-x 0 0;padding-top:18px;margin:0 auto;width:900px;text-align:'.$_dir.'">
			<table cellpadding="0" cellspacing="0" width="652" align="center" style="font-family:sans-serif;font-size:12px;color:#505050;border:1px solid #dfe0e0;border-bottom:none;background:#fff">
				<tbody><tr style="font-family:sans-serif;font-size:12px;color:#505050">
					<td valign="top" style="font-family:sans-serif;font-size:12px;color:#505050;padding:30px 45px 0 45px">
						<div style="font-family:sans-serif;font-size:12px;color:#505050">
							<p style="font-family:sans-serif;font-size:12px;color:#505050;padding:0;margin:0;padding-bottom:15px">
		'._lang("SA").' ,</p>
	
	<p style="font-family:sans-serif;font-size:12px;color:#505050;padding:0;margin:0;padding-bottom:15px">'.$mail_content.'</p>
				<p style="font-family:sans-serif;font-size:12px;color:#505050;padding:0;margin:0;padding-bottom:15px">'._lang("Telemedicine Team").'</p>
						</div>
					</td>
				</tr>
			</tbody></table>
		</div>
		<div style="font-family:sans-serif;font-size:12px;color:#c3eded;background:#565155;width:900px;margin:0 auto;text-align:center;padding-bottom:25px;padding-top:25px;">
			© Telemedicine 2015 | '.$_mail.'
		</div>
	</div>
	</div>';
	return $message;
}

function radio_send_mail($to="",$subject="",$message=""){
	$config['useragent'] = 'CodeIgniter';
	$config['protocol'] = 'smtp';
	$config['smtp_host'] = 'ssl://smtp.googlemail.com';
	$config['smtp_user'] = 'shamsitnoreply@gmail.com';
	$config['smtp_pass'] = 'shams-it';
	$config['smtp_port'] = 465; 
	$config['smtp_timeout'] = 5;
	$config['wordwrap'] = TRUE;
	$config['wrapchars'] = 76;
	$config['mailtype'] = 'html';
	$config['charset'] = 'utf-8';
	$config['validate'] = FALSE;
	$config['priority'] = 3;
	$config['crlf'] = "\r\n";
	$config['newline'] = "\r\n";
	$config['bcc_batch_mode'] = FALSE;
	$config['bcc_batch_size'] = 200;
	$this->load->library('email'); // Note: no $config param needed
	$this->email->initialize($config);
	$this->email->from('shamsitnoreply@gmail.com', 'shamsitnoreply@gmail.com');
	$this->email->to($to);
	$this->email->subject(_lang("Telemedicine - ".$subject));
	$this->email->message($message);
	$this->email->send();
}

?>