<?php
class Admin_Controller extends MY_Controller{
	protected $_backstage_dir;
	protected $_has_access = FALSE;
	private $_has_error = FALSE;
	public $_page=1;
	public $_per_page=25;
	protected $_special_privilaged_controllers = array('contact');
	protected $privilages = array("customer_service"=>array("order"=>array("index","add","edit","delete","preview"),"proffessional"=>array("index","add","edit","delete")));
	protected $_trash = false;
	protected $_model = "";
	protected $is_admin_panel = true;
	function __construct(){
		parent::__construct();
		//dump_exit($this->session->get_userdata());
		$this->load->model('admin_m');
		$this->load->helper('form');
		$this->load->library('form_validation');
		$this->data['meta_title'] = config_item("meta_title");
		$this->data['admin_head_title'] = _lang("Dashboard");
		$this->data["Module_title"] = $this->data['site_name'];
		$this->_backstage_dir = config_item("backstage_dir");
		$this->data['_backstage_dir'] = $this->_backstage_dir;		
		$this->data['_per_page'] = $this->_per_page;
		$this->data['_page'] = $this->_page;
		$this->data['basic_actions'] = array('index','add');
		$this->data['user_color'] = $this->meta_m->get_usermeta('','user_color');
		$this->data['default_avatar'] = ci_site_url('assets/images/avatar.png');
		$this->site_lang = "ar";
		$exception_uris = array(
			$this->_backstage_dir.'/user/login',
			$this->_backstage_dir.'/user/lock',
			$this->_backstage_dir.'/user/logout',
		);
		if (in_array(uri_string(), $exception_uris) == FALSE) {
			$check_session = true;
			if(!empty($_SERVER['HTTP_REFERER']) && strpos($_SERVER['HTTP_REFERER'],"user/login")>-1) $check_session = false;
			if ($this->user_m->loggedin() == FALSE && $check_session) {
				$previous = $this->_method !='index'?$this->_controller.'/'.$this->_method:$this->_controller.'/';
				
				redirect($this->_backstage_dir.'/user/login?to_url='.$previous);
			}elseif(!$this->has_privilage()){
				
				if(!$this->have_customized_privilage())
					$this->problem_view('access');
			}else $this->can_access();
		}else $this->can_access();
		
		$this->site_dir = "rtl";
		$this->data['direction'] = $this->site_dir;
	}
	
	protected function have_customized_privilage(){
		return false;
	}
	
	private function can_access(){
		if($this->uri->segment(4,0)==0 && ($this->_method =='delete'|| $this->_method =='edit')){
			$this->problem_view('access');return;
		}
		//if($this->_method =='delete')
		$this->data['has_access'] = true;
		$this->_has_access = true;
		$this->current_user_privilages();
	}
	
	private function user_have_operations(){
		@$priv_controller = $this->data['privilages'][$this->_controller];
		foreach($this->data['basic_actions'] as $action)
			if(is_array($priv_controller))unset($priv_controller[array_search($action,$priv_controller)]);
		return count($priv_controller) > 0?true:false;
	}
	
	protected function problem_view($reason=''){
		$this->site_dir = "rtl";
		$this->data['direction'] = $this->site_dir;
		$this->data['Module_title'] = _lang("Invalid Access");
		$this->data['is_404'] = true;
		$this->data['has_access'] = false;
		$this->sub_view('errors/404');
		$this->load_admin_view();
		$this->_has_error = true;
	}
	
	protected function operation_column_visibility(){
		if($this->data['is_admin'] || $this->user_have_operations())
			$this->data['show_operations'] = true;
		else $this->data['show_operations'] = false;
	}
	
	protected function current_user_privilages(){
		if(strlen($this->session->userdata('id'))==0)return array();
		$privilages = $this->user_m->get($this->session->userdata('id'));
		if(empty($privilages))return array();
		$privilages = $privilages->user_privilages;
		if($privilages != 'administrator_eb4d8'){
			$privilages = $this->privilages[$privilages];
			$this->data['is_admin'] = false;
		}else $this->data['is_admin'] = true;
		$this->data['privilages'] = $privilages;
	}
	
	protected function valid_object($obj=''){
		if(!empty($obj))return true;
		$this->problem_view('valid');
		return false;
	}
	
	protected function has_privilage(){
		if($this->router->fetch_class() == 'dashboard')return true;
		$this->db->select('user_privilages');
		$this->db->where('id',$this->session->userdata('id'));
		$user = $this->db->get(USERS_TABLE);
		$user = $user->row();
		if(empty($user))return false;
		if($user->user_privilages=='administrator_eb4d8')return true;
		else $user = $this->privilages[$user->user_privilages];
		//customized cases
		
		if($this->router->fetch_class()=="user"&&
		$this->router->fetch_method()=="edit"&&
		$this->session->userdata('id')==$this->uri->segment(4)){
			$this->data['privilages'][$this->router->fetch_class()] = array($this->router->fetch_method());
			$user[$this->router->fetch_class()] = array($this->router->fetch_method());
		}
		return (!empty($user[$this->router->fetch_class()]) && in_array($this->router->fetch_method(),$user[$this->router->fetch_class()]));
	}
	
	protected function load_admin_view($_login_view=FALSE){
		if($this->_has_error){
			return;
		}
		if($_login_view){
			$this->load->view($this->_backstage_dir.'/components/login-head', $this->data);
			$this->load->view($this->data["subview"], $this->data);
			$this->load->view($this->_backstage_dir.'/components/login-foot', $this->data);
		}else{
			$this->load->view($this->_backstage_dir.'/components/header', $this->data);
			$this->load->view($this->_backstage_dir.'/mine_layout_main', $this->data);
			$this->load->view($this->_backstage_dir.'/components/footer', $this->data);
		}
	}
	protected function load_modal_view($view_data){
		$this->load->view($this->_backstage_dir.'/mine_layout_modal', $view_data);
	}
	
	protected function sub_view($sub_view){
		$this->data['subview'] = $this->_backstage_dir.'/'.$sub_view;
	}
	
	/*public function trash(){
		$this->_trash = "trash";
		$this->index();
	}*/
	/*Restore item from Trash*/
	public function restore ($id){
		if(!$this->_has_access)return;
		if(empty($id))
			redirect($this->_backstage_dir.'/'.$this->data["_controller"]);
		$model_name = $this->_model;
		$result = $this->$model_name->delete($id,true);
		if($result){
			if(!empty($id))
				$msg = _lang(ucfirst($this->_module).' restored successfully');				
		}else{ 
			$this->session->set_flashdata('result_type', 'danger');
			if(!empty($id))
				$msg = _lang('Error while restoring '.ucfirst($this->_module));
		}
		$this->session->set_flashdata('result', $msg);
		redirect($this->_backstage_dir.'/'.$this->data["_controller"]);
	}
	/*Totally remove item from Database*/
	public function remove ($id){
		if(!$this->_has_access)return;
		if(empty($id))
			redirect($this->_backstage_dir.'/'.$this->data["_controller"]);
		$model_name = $this->_model;
		$result = $this->$model_name->remove($id);
		if($result){
			if(!empty($id))
				$msg = _lang(ucfirst($this->_module).' removed successfully');				
		}else{ 
			$this->session->set_flashdata('result_type', 'danger');
			if(!empty($id))
				$msg = _lang('Error while removing '.ucfirst($this->_module));
		}
		$this->session->set_flashdata('result', $msg);
		redirect($this->_backstage_dir.'/'.$this->data["_controller"]."/trash");
	}
	/*Move Item to Trash*/
	public function delete ($id){
		if(!$this->_has_access)return;
		if(empty($id))
			redirect($this->_backstage_dir.'/'.$this->data["_controller"]);
		$model_name = $this->_model;
		$additional_par = "";
		if($this->_model == "advertiser_rating_m"){
			$_obj = $this->advertiser_rating_m->get($id);
			$additional_par .= "/index/".$_obj->rate_advertiser_id;
		}
		/*$result = $this->$model_name->delete($id);*/
		$result = $this->$model_name->remove($id);
		if($result){
			if(!empty($id))
				$msg = _lang(ucfirst($this->_module).' deleted successfully');				
		}else{ 
			$this->session->set_flashdata('result_type', 'danger');
			if(!empty($id))
				$msg = _lang('Error while deleting '.ucfirst($this->_module));
		}
		$this->session->set_flashdata('result', $msg);
		redirect($this->_backstage_dir.'/'.$this->data["_controller"].$additional_par);
	}	
}