<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed'); 
class Frontend_Controller extends MY_Controller{	
	public $_page=1;
	public $_per_page=10;
	public $page_title = "";
	protected $is_member_logged_in;
	protected $member_status = "";
	public $breadcrumbs_arr = array();
	protected $_objects = "";
	protected $current_lang = "";
	function __construct(){
		$this->_frontend = true;
		parent::__construct();
		$this->data["breadcrumbs_home_url"] = ci_site_url();
		$this->data["is_home"] = false;
		
		$this->load->model("option_m");
		$this->get_social_links();
		$this->get_meta_options();
		$this->prepare_footer_pages();
		// $this->mine_save_current_visit();
		//$this->load->library("hejri");
		$this->data["base_url"] = base_url();
	}
	private function mine_save_current_visit(){
		$this->load->model("option_m");
		$option_name = "total_visits";
		$old_val = $this->option_m->ci_get_option($option_name);
		$old_val++;
		$op_result = $this->option_m->ci_update_option($option_name,$old_val);
		$option_name = "online_users";
		$old_val = $this->option_m->ci_get_option($option_name);
		$online_users_date = $this->option_m->ci_get_option("online_users_date");
		if(strtotime($online_users_date) == strtotime(date("Y-m-d"))){
			$old_val++;			
		}else{
			$old_val = 1;
			$this->option_m->ci_update_option("online_users_date",date("Y-m-d"));
		}
		$op_result = $this->option_m->ci_update_option($option_name,$old_val);		
	}	
	protected function switch_my_Language(){
        $language = $this->input->get('lang');
        if(!empty($language)){			
            $this->session->set_userdata('zlanguage', $language);
			$_url = $this->_controller;
			$item_id = $this->uri->segment(3, 0);
			if(!empty($item_id)){
				$_url .= "/".$item_id;
			}
			$lang = $this->session->userdata('zlanguage');
            redirect($_url);
        }
    }
	protected function load_template_view($view="",$options=array()){		
		$this->data["page_title"] = config_item("frontend_title")." - ".$this->page_title;
		$this->data["objects_name"] = $this->_objects;
		$this->template_data($view,$options);
		$this->load->view("templates/".$this->data["current_template"]."/header",$this->data);		
		$this->load->view("templates/".$this->data["current_template"]."/".$this->data["view"],$this->data);
		$this->load->view("templates/".$this->data["current_template"]."/footer",$this->data);
	}
	
	private function template_data($view="",$options=array()){
		$current_template = ci_get_option("current_template");
		$current_template = empty($current_template)?"default":$current_template;
		$this->data["view"] = empty($view)?"index":$view;
		$this->data["current_template"] = $current_template;
		foreach($options as $key => $option)$this->data[$key] =$option;
		$this->data["data"] = $this->data;
	}
	
	private function make_slug_key($tmp,$var_name){
		foreach($tmp as $obj)
			$this->data[strtolower($var_name)][$obj->layout_slug] = $obj;
	}
	
	protected function load_404(){
		$this->data["breadcrumbs_current_path"] = _lang("404 Page");
		$this->data["breadcrumbs_page_desc"] = _lang("Page not found");
		$this->data["is_404"] = true;
		$this->load_template_view("404");
	}
	
	private function fill_news_bar($limit = 10){
		$this->load->model("news_m");
		$this->news_m->limit    = $limit;
		$this->data["newsbar_items"] 	= $this->news_m->get('',false,true,false,"",true);
	}
	private function get_adsense($limit = 1){
		$this->load->model("ads_m");
		$this->ads_m->limit    = $limit;
		$this->db->where("ads_status",1);
		$this->data["sidebar_ads"] 	= $this->ads_m->get('',false,true,false,"",true);
		//dump_exit($this->data["sidebar_ads"]);
	}
	private function get_contact_details(){
		$this->data["contact_address"] = $this->option_m->ci_get_option("contact_address");
		$this->data["contact_phone"] = $this->option_m->ci_get_option("contact_phone");
		$this->data["contact_mobile"] = $this->option_m->ci_get_option("contact_mobile");
		$this->data["contact_email"] = $this->option_m->ci_get_option("admin_email");
		$this->data["postal_number"] = $this->option_m->ci_get_option("postal_number");
		$this->data["postal_box"] = $this->option_m->ci_get_option("postal_box");
	}
	private function get_social_links(){
		$social_arr = array();
		$social_arr["social_facebook_url"] = $this->option_m->ci_get_option("app_face");
		$social_arr["social_twitter_url"] = $this->option_m->ci_get_option("app_twitter");
		$social_arr["social_youtube_url"] = $this->option_m->ci_get_option("app_youtube");
		$social_arr["social_instagram_url"] = $this->option_m->ci_get_option("app_ins");
		$social_arr["social_linked_url"] = $this->option_m->ci_get_option("app_linkd");
		$this->data["social_arr"] 	= $social_arr;
	}
	private function get_meta_options(){
		$options_to_get = array("site_email",
			// "total_visits",
			// "online_users",
            "app_face",
            "app_linked",
            "app_youtube",
            "app_twitter",
            "app_whatsapp",
            "app_ins",
            "app_massenger",
			"app_gplus",
			"app_snapchat"
			);
		foreach($options_to_get as $option){
			$this->data[$option] = $this->option_m->ci_get_option($option);
		}
	}
	private function prepare_footer_pages($limit=10){
		$this->load->model("page_m");
		$this->page_m->limit    = $limit;
		$this->page_m->set_order_by("pag_menu_order ASC");
		$this->db->where("pag_show_in_menu",1);
		$this->data["footer_pages"] 	= $this->page_m->get('',false,true,false,"",true);
	}
	private function load_slider(){
		$this->load->model("slider_m");
		$this->db->where("slid_status",1);
		$this->slider_m->set_order_by("slid_order ASC");
		$this->data["home_slides"] = $this->slider_m->get('',false,true,$this->_trash);
	}
}