<?php
class Category_m extends MY_Model{	
	protected $_table_name = CATEGORIES_TABLE;
	public $_order_by = ' cat_app_order ASC';
	protected $_table_prefix = "cat_";
	public $cats =array();
	public $repeated = array();
	public $tree_cats_value = "id";
	public $rules = array(
		'cat_name' => array(
			'field' => 'cat_name', 
			'label' => "اسم القسم", 
			'rules' => 'trim|required|xss_clean'
		)
	);
	
	function __construct() {
		parent::__construct();
		
	}
	
	public function apply_filter($once = false){		
		if(!empty($_GET) && empty($_GET["search"])){			
			foreach($_GET as $key=>$value){
				if(empty($value))continue;
				switch($key){
					case "s":
						$this->db->where(" (  cat_name LIKE '%".$value."%'  ) ");
					break;
				}
			}
		}
	}
	public function get_with_parent ($id = NULL, $single = FALSE){
		$this->db->select($this->_table_name.'.*, p.cat_name as parent_title');
		$this->db->join($this->_table_name.' as p', $this->_table_name.'.cat_parent=p.cat_id', 'left');
		return parent::get($id, $single,true,true,"",true);
	}
	public function get_no_parents($id = '',$only_parents=false){
		// Fetch pages without parents
		$this->db->select('cat_id, cat_name');
		if(!empty($id)){
			$cat = $this->get($id);
			$this->db->where('cat_id != ', $id);
		}
		$categories = parent::get('',false,true,false,"",true);
		$array = array();
		if (count($categories)) {
			foreach ($categories as $cat) {
				$array[$cat->cat_id] = $cat->cat_name;
			}
		}
		return $array;
	}	
	public function get_leveled($level = 0,$parent = 0){
		if(!empty($parent))$this->db->where('cat_parent',$parent);
		return $this->db->get($this->_table_name)->result();
	}	
	public function cat_has_children($id){
		$this->db->where('cat_parent',$id);
		return (count($this->db->get($this->_table_name)->result()) > 0);
	}
	
	private function _dashes($n = ''){
		$out = ' ';
		for($i=0;$i<$n;$i++)$out .=' - ';
		return $out;
	}
	
	public function get_tree_cats($level=0,$max='',$parent='',$unset=FALSE){
		if($unset){
			$this->cats = array();
			$this->repeated = array();
		}
		if(empty($max))$max = $this->max_level();
		/*if($unset)
			echo "LEVEL : ".$level." & MAX : ".$max."<br>";*/
		while($level<=$max){
			$cats = $this->get_leveled($level,$parent);
			/*if($unset){
				echo $this->db->last_query()."<br>";
				dump($cats);
			}*/
			for($i=0;$i<count($cats);$i++){
				$cat = $cats[$i];
				if(in_array($cat->cat_id,$this->repeated))continue;
				else $this->repeated[] = $cat->cat_id;
				if(!$this->cat_has_children($cat->cat_id)){
					if($this->tree_cats_value == "id")
						$this->cats[''.$cat->cat_id] = $this->_dashes($level).$cat->cat_name;					
				}else{
					if($this->tree_cats_value == "id")
						$this->cats[''.$cat->cat_id] = $this->_dashes($level).$cat->cat_name;
					$this->get_tree_cats($level+1,$max,$cat->cat_id);
				}
			}
			$level++;
		}	
	}
}