<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Contact extends Frontend_Controller{
	protected $_trash = false;
	private $setting_options = array(
			"site_address","site_email","site_phone","site_mobile","site_fax"
		);
	protected $contact_fields = array("contact_name","contact_email","contact_title","contact_message");
	protected $_objects = "contact";
	function __construct(){
		parent::__construct();
	}	
	public function index(){
		/* Load About Blocks */
		if(!empty($this->setting_options)){
			foreach($this->setting_options as $_option){
				$this->data[$_option] = $this->option_m->ci_get_option($_option);
			}
		}

		$site_name = ($this->current_lang == "ar")? config_item("frontend_title"):config_item("frontend_title_en");
        $this->data["page_title"] = $site_name." - "._lang("Contact us");		
		$this->load->model("contact_m");			
		$rules = $this->contact_m->rules;
		$this->form_validation->set_rules($rules);		
		// Process the form
		if ($this->form_validation->run() == TRUE) {
			$data = $this->contact_m->array_from_post($this->contact_fields);
			$result = $this->contact_m->save($data);
			if($result){
				$msg = ($this->current_lang == "ar")?"شكرا لك تم ارسال رسالتك الى ادارة الموقع ، سوف نقوم بالتواصل معك في أقرب وقت":"Your message was received, we will reply you as soon as we can";					
			}else{ 
				$this->session->set_flashdata('result_type', 'danger');
				$msg = ($this->current_lang == "ar")?"عفوا حدث خطأ اثناء الارسال ، من فضلك حاول مرة اخرى":"Sorry! Error happened while sending your message, please try again";					
			}
			$this->session->set_flashdata('result', elang($msg));
			redirect('contact/');				
		}
		/* Load options*/
		$this->load_template_view("contact/single",$this->data);
	}
}