<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Proffessionals extends Front_Content{
	protected $_single = "proffessional";	
	protected $_objects = "proffessionals";	
	protected $_views = "proffessionals";		
	protected $_title = "Proffessionals";
	protected $_module = "Proffessionals";
	protected $_model = "profs_m";
	protected $_name_field = "profs_name";
	protected $table_prefix = "profs_";
	protected $name_field = "name";
	protected $_trash = false;
	protected $has_upload = true;
	protected $form_fields = array('profs_name','profs_cat_id','profs_city_id','profs_about');
	
	function __construct(){
		parent::__construct();
		$this->load->model($this->_model);
	}

	public function index($id = NULL)
	{
		// dump_exit($profs);

		$this->load->model("profs_m");
		// $this->profs_m->limit = 5;		
		$profs = $this->profs_m->get();
		// dump_exit($profs);


		$this->load->model("category_m");
		$parent_categories = $this->category_m->get('',false,true,$this->_trash,"",false);
		$categories_options = array();
		foreach($parent_categories as $_parent_category){
			$categories_options[$_parent_category->cat_id] = $_parent_category->cat_name;
		}
		unset($parent_categories);unset($_parent_category);
		$this->data["categories_options"] = $categories_options;
		//
		$this->load->model("city_m");
		$parent_cities = $this->city_m->get('',false,true,$this->_trash,"",true);
		$cities_options = array();
		foreach($parent_cities as $_parent_city){
			$cities_options[$_parent_city->city_id] = $_parent_city->city_name;
		}
		unset($parent_cities);unset($_parent_city);
		$this->data["cities_options"] = $cities_options;

		foreach($profs as $_object){			
			$cat_id_field = "profs_cat_id";
			if(!empty($_object->$cat_id_field) && !empty($categories_options[$_object->$cat_id_field])){
				$_object->cat_name = $categories_options[$_object->$cat_id_field];
			}else{
				$_object->cat_name = " بدون قسم ";
			}
			$city_id_field = "profs_city_id";
			if(!empty($_object->$city_id_field) && !empty($cities_options[$_object->$city_id_field])){
				$_object->city_name = $cities_options[$_object->$city_id_field];
			}else{
				$_object->city_name = " بدون مدينة ";
			}			
		}

		$this->data["profs"] = $profs;

		// Load the view
		$this->load_template_view($this->_views."/index",$this->data);
	}

	public function addjob(){
		$_model = $this->_model;
		$this->data["proffessionals"] = $this->$_model->get_new();

		$this->load->model("category_m");
		$categories = $this->category_m->get('',false,true,$this->_trash,"",true);
		$this->data["categories"] = $categories;
		$categories_arr = array();
		foreach($categories as $category){
			$categories_arr[$category->cat_id] = $category->cat_name;
		}
		$this->data["categories_options"] = $categories_arr;
		//
		$this->load->model("city_m");
		$cities = $this->city_m->get('',false,true,$this->_trash,"",true);
		$this->data["cities"] = $cities;
		$cities_arr = array();
		foreach($cities as $city){
			$cities_arr[$city->city_id] = $city->city_name;
		}
		$this->data["cities_options"] = $cities_arr;

		// Set up the form
		if(!empty($_POST)){
			//var_dump($_POST);die();
			$rules = $this->$_model->rules;
			$this->form_validation->set_rules($rules);
			// Process the form
			// dump_exit($this->form_validation->run());
			if ($this->form_validation->run() == TRUE) {
				$data = $this->$_model->array_from_post($this->form_fields);
				if($this->has_upload){
					$this->upload_input_name = $this->table_prefix."thumb_id";
					if(!empty($_FILES[$this->upload_input_name]['size'])){
						$thumb_id = $this->_u($this->upload_input_name);
						if(!empty($thumb_id))
							$data[$this->upload_input_name] = $thumb_id;
					}
				}
				$data["profs_phone"] = $this->input->post("profs_phone_1").'-'.$this->input->post("profs_phone_2");			
				$result = $this->$_model->save($data, $id);
				$the_id = empty($id)? $this->db->insert_id() : $id;
				if($result){
					if(!empty($id)){
							$msg = _lang(ucfirst($this->_module).' updated successfully');
					}else
						$msg = _lang(ucfirst($this->_module).' added successfully');
				}else{
					$this->session->set_flashdata('result_type', 'danger');
					if(!empty($id))$msg = _lang('Error while updating '.$this->_module);
					else $msg = _lang('Error while adding '.$this->_module);
				}
				$this->session->set_flashdata('result', elang($msg));
				$additional_par = "";
				redirect($this->_views.'/index');
			}
		}
		
		// Load the view
		$this->load_template_view("proffessionals/addjob",$this->data);
	}

	public function preview($id = NULL)
	{
		if(empty($id)){
			redirect($this->_views.'/index');
		}

		$_model = $this->_model;
		$prof = $this->$_model->get($id);

		$this->load->model("category_m");
		$categories = $this->category_m->get('',false,true,$this->_trash,"",true);
		$this->data["categories"] = $categories;
		$categories_arr = array();
		foreach($categories as $category){
			$categories_arr[$category->cat_id] = $category->cat_name;
		}
		$this->data["categories_options"] = $categories_arr;
		//
		$this->load->model("city_m");
		$cities = $this->city_m->get('',false,true,$this->_trash,"",true);
		$this->data["cities"] = $cities;
		$cities_arr = array();
		foreach($cities as $city){
			$cities_arr[$city->city_id] = $city->city_name;
		}
		$this->data["cities_options"] = $cities_arr;

		$cat_id_field = "profs_cat_id";
		if(!empty($prof->$cat_id_field) && !empty($categories_options[$prof->$cat_id_field])){
			$prof->cat_name = $categories_options[$prof->$cat_id_field];
		}else{
			$prof->cat_name = " بدون قسم ";
		}
		$city_id_field = "profs_city_id";
		if(!empty($prof->$city_id_field) && !empty($cities_options[$prof->$city_id_field])){
			$prof->city_name = $cities_options[$prof->$city_id_field];
		}else{
			$prof->city_name = " بدون مدينة ";
		}	

		$this->data["prof"] = $prof;
		// Load the view
		$this->load_template_view($this->_views."/preview",$this->data);
	}
}