<?php
class Settings extends Admin_Controller {
	private $setting_options = array(
			"site_email",
			"site_phone",
			"site_mobile",
			"site_fax",
			"site_address",
            "app_face",
            "app_twitter",
            "app_linked",
            "app_ins",
            "app_youtube",
			"app_gplus",
			"app_snapchat"
		);
    public function __construct(){		
        parent::__construct();
		$this->data["Module_title"] = _lang("Settings");
		$this->load->model('option_m');
    }
    public function index() {
		if(!$this->_has_access)return;
		$this->form_validation->set_rules($this->option_m->rules_admin);
		if ($this->form_validation->run() == TRUE) {
			$data = $this->option_m->array_from_post($this->setting_options);
			$result = true;
			foreach($data as $k => $v){
				$op_result = $this->option_m->ci_update_option($k,$v);
				if(empty($op_result))
					$result = false;
			}
			if($result){
				$this->session->set_flashdata('result', elang('Settings updated successfully'));
			}else{ 
				$this->session->set_flashdata('result_type', 'danger');
				$this->session->set_flashdata('result', elang('Error while updating settings'));
			}
			redirect($this->_backstage_dir.'/settings');	
		}
		if(!empty($this->setting_options)){
			foreach($this->setting_options as $_option){
				$this->data[$_option] = $this->option_m->ci_get_option($_option);
			}
		}		
		$this->sub_view('settings/edit');
		$this->load_admin_view();
    }	
}