<?php
class User_type extends Admin_Controller
{
	protected $_user_type;
	protected $_module = "user";
	protected $_trash = false;	
	protected $_model = "user_m";	
	protected $_extra_meta = array();
	public function __construct ()
	{
		parent::__construct();
		$this->load->library('Mine_pagination');
	}
	
	private function apply_user_type(){
		if(!empty($this->_user_type))
			$this->db->where("user_privilages",$this->_user_type);
		else{
			$user_types = config_item("user_types");
			if(!empty($user_types))foreach($user_types as $_type)
				$this->db->where("user_privilages != '".$_type."'");
		}	
	}
	
	private function privilages($id=''){
		if($this->input->post('make_admin')=='true'){
			return $this->user_m->save(array('user_privilages'=>'administrator_eb4d8'), $id);
		}
		return $this->user_m->save(array('user_privilages'=>"customer_service"), $id);
	}
	
	protected function extra_usermeta($id="",$the_id=""){
		foreach($this->_extra_meta as $k => $v){
			$_data = array('meta_key'=>$k,'meta_value'=>$this->input->post($v),
			'meta_type'=>'user','item_id'=>$the_id);
			if(!empty($id))$this->meta_m->update_usermeta($id,$k,$_data);
			else $this->meta_m->save($_data);
		}
	}

	public function index(){
		if(!$this->_has_access)return;
		$this->operation_column_visibility();
		$_page = ci_get_str_parameter("_page");
		if(!empty($_page)){
			$this->_page = $_page;
		}
		$this->data["_page"] = $this->_page;
		$this->data["filter_user_types"] = array(""=>_lang("User type"),"yes"=>_lang("Administrator"),"no"=>_lang("Customer service"));
		// apply Filter Rules
		//$this->user_m->apply_filter();
		//get all users count for pagniation
		$this->apply_user_type();
		$all_users = $this->user_m->get_all(true,$this->_trash);
		$all_users_count = count($all_users);
		// Fetch all users pagniated
		$pagination                = new Mine_pagination($this->_page, $this->_per_page, $all_users_count);
		$this->user_m->limit  = $this->_per_page;
		$this->user_m->offset= $pagination->offset();
		if(!empty($_GET["order"]) && !empty($_GET["orderby"]))
			$this->user_m->set_order_by($_GET["orderby"]." ".$_GET["order"]);
		else
			$this->user_m->set_order_by("ID DESC");
		$this->apply_user_type();
		$this->data['users'] = $this->user_m->get('',false,true,$this->_trash);
		$this->data["links"]        = ci_draw_pagination_links($pagination, $this->_controller, $this->_page);
		/*dump_exit($this->db->last_query());*/
		// Load view
		$this->sub_view($this->data["_controller"].'/index');
		$this->load_admin_view();
	}
	
	public function add(){
		if(!$this->_has_access)return;
		$this->edit();
	}

	public function edit ($id = NULL)
	{
		if(!$this->_has_access)return;
		// Fetch a user or set a new one
		if ($id) {
			$this->apply_user_type();
			$this->data['user'] = $this->user_m->get($id);
			if(!$this->valid_object($this->data['user']))return;
			count($this->data['user']) || $this->data['errors'][] = 'User could not be found';
		}
		else {
			$this->data['user'] = $this->user_m->get_new();
		}
		// Set up the form
		$rules = $this->user_m->rules_admin;
		$id || $rules['user_password']['rules'] .= '|required';
		$this->form_validation->set_rules($rules);
		
		// Process the form
		if ($this->form_validation->run() == TRUE) {
			$data = $this->user_m->array_from_post(array('user_name','user_nickname', 'user_email','user_lang'));
			if(!empty($_POST['user_password'])){
				$data = $this->user_m->array_from_post(array('user_password'),$data);
				$data['user_password'] = $this->user_m->hashv($data['user_password']);
			}
			if(!empty($this->_user_type))
				$data["user_privilages"] = $this->_user_type;
			$result = $this->user_m->save($data, $id);
			$the_id = empty($id)? $this->db->insert_id() : $id;
			if($result && !empty($_FILES['user-avatar']['size'])){
				$_data = array('meta_key'=>'avatar','meta_value'=>$this->_u('user-avatar',true),
			'meta_type'=>'user','item_id'=>$the_id);
				$this->load->model('meta_m');
				if(!empty($id))$this->meta_m->update_usermeta($id,'avatar',$_data);
				else $this->meta_m->save($_data);
			}
			if(empty($this->_user_type))$result &= $this->privilages($the_id);
			$this->extra_usermeta($id,$the_id);
			if($result){
				if(!empty($id)){
					if(!empty($this->data['is_admin'])){						
						$msg = _lang(ucfirst($this->_module).' updated successfully');
					}else{
						$msg = _lang('your profile has been updated successfully');
					}
				}else 
					$msg = _lang(ucfirst($this->_module).' added successfully');
			}else{ 
				$this->session->set_flashdata('result_type', 'danger');
				if(!empty($id))$msg = _lang('Error while updating '.$this->_module);
				else $msg = _lang('Error while adding '.$this->_module);
			}
			$this->session->set_flashdata('result', elang($msg));
			if(!empty($id) && $id == $this->session->userdata('id')){
				$_data = array(
					'name' => $data['user_name'],
					'email' => $data['user_email'],
					'nickname' =>  $data['user_nickname']
				);
				$this->session->set_userdata($_data);
			}
			if(!empty($this->data['is_admin'])){
				redirect($this->_backstage_dir.'/'.$this->data["_controller"]);
			}else{
				redirect($this->_backstage_dir.'/'.$this->data["_controller"].'/edit/'.$id);
			}
		}
		
		// Load the view
		$this->sub_view($this->data["_controller"].'/edit');
		$this->load_admin_view();
	}

	public function delete ($id)
	{
		if(!$this->_has_access)return;
		if($this->session->userdata('id') != $id){
			$this->load->model('meta_m');
			$meta_before = $this->meta_m->get_usermeta($id,'avatar');
			@unlink(FCPATH.'media/'.$meta_before->meta_value);
			/*$result = $this->user_m->delete($id);*/
			$result = $this->user_m->remove($id);
		}
		if($result){
			if(!empty($id))
				$msg = _lang(ucfirst($this->_module).' deleted successfully');				
		}else{ 
			$this->session->set_flashdata('result_type', 'danger');
			if(!empty($id))
				$msg = _lang('Error while deleting '.ucfirst($this->_module));
		}
		$this->session->set_flashdata('result', $msg);
		redirect($this->_backstage_dir.'/'.$this->data["_controller"]);
	}

	public function login (){		
		$this->load->model("user_m");
		/*dump_exit($this->user_m->hashv("E1H33@@Org-19"));*/		
		// Redirect a user if he's already logged in
		$get_redirect = $this->input->post("to_url");
		$get_redirect = (!empty($get_redirect))?$get_redirect:"dashboard";
		$get_redirect_arr = explode("/",$get_redirect);
		// Redirect a user if he's already logged in
		$dashboard = $this->_backstage_dir.'/'.$get_redirect_arr[0];
		if($this->user_m->loggedin()){redirect($dashboard);die();}
		// Set form
		$rules = $this->user_m->rules;
		$this->form_validation->set_rules($rules);
		
		// Process form
		if ($this->form_validation->run() == TRUE) {
			// We can login and redirect
			if ($this->user_m->login() == TRUE) {
				redirect($dashboard);
			}
			else {
				$this->session->set_flashdata('result_type', 'danger');
				$this->session->set_flashdata('result', _lang('That email/password combination does not exist'));
				redirect($this->_backstage_dir.'/user/login', 'refresh');
			}
		}
		
		$userdata = array(
					'name' => "",
					'email' => "",
					'lang' => "",
					'id' => "",
					'nickname' => "",
					'loggedin' => "",
				);
		$this->session->unset_userdata($userdata);
		// Load view
		$this->sub_view('user/login');
		$this->load_admin_view(TRUE);
	}

	public function logout ()
	{
		$this->user_m->logout();
		redirect($this->_backstage_dir.'/user/login');
	}
	
	public function lock ()
	{
		$data = array('loggedin' => FALSE);
		$this->session->set_userdata($data);		
		$this->sub_view('user/lock');
		$this->load_admin_view(TRUE);
	}

	public function _unique_email ($str)
	{
		// Do NOT validate if email already exists
		// UNLESS it's the email for the current user
		
		$id = $this->uri->segment(4);
		$this->db->where('user_email', $this->input->post('user_email'));
		!$id || $this->db->where('ID !=', $id);
		$user = $this->user_m->get();
		if (count($user)) {
			$this->form_validation->set_message('_unique_email', '%s should be unique');
			return FALSE;
		}
		return TRUE;
	}
	
	public function _unique_user_name($str)
	{
		// Do NOT validate if name already exists
		// UNLESS it's the name for the current user
		
		$id = $this->uri->segment(4);
		$this->db->where('user_name', $this->input->post('user_name'));
		!$id || $this->db->where('ID !=', $id);
		$user = $this->user_m->get();
		if (count($user)) {
			$this->form_validation->set_message('_unique_name', '%s should be unique');
			return FALSE;
		}
		return TRUE;
	}
	
}