<?php
class City_m extends MY_Model{	
	protected $_table_name = CITIES_TABLE;
	public $_order_by = ' city_id ASC';
	protected $_table_prefix = "city_";
	public $citys =array();
	public $repeated = array();
	public $tree_citys_value = "id";
	public $rules = array(
		'city_name' => array(
			'field' => 'city_name', 
			'label' => "اسم القسم", 
			'rules' => 'trim|required|xss_clean'
		)
	);
	
	function __construct() {
		parent::__construct();
		
	}
	
	public function apply_filter($once = false){		
		if(!empty($_GET) && empty($_GET["search"])){			
			foreach($_GET as $key=>$value){
				if(empty($value))continue;
				switch($key){
					case "s":
						$this->db->where(" (  city_name LIKE '%".$value."%'  ) ");
					break;
				}
			}
		}
	}
	public function get_with_parent ($id = NULL, $single = FALSE){
		$this->db->select($this->_table_name.'.*, p.city_name as parent_title');
		$this->db->join($this->_table_name.' as p', $this->_table_name.'.city_parent=p.city_id', 'left');
		return parent::get($id, $single,true,true,"",true);
	}
	public function get_no_parents($id = '',$only_parents=false){
		// Fetch pages without parents
		$this->db->select('city_id, city_name');
		if(!empty($id)){
			$city = $this->get($id);
			$this->db->where('city_id != ', $id);
		}
		$cities = parent::get('',false,true,false,"",true);
		$array = array();
		if (count($cities)) {
			foreach ($cities as $city) {
				$array[$city->city_id] = $city->city_name;
			}
		}
		return $array;
	}	
	public function get_leveled($level = 0,$parent = 0){
		if(!empty($parent))$this->db->where('city_parent',$parent);
		return $this->db->get($this->_table_name)->result();
	}	
	public function city_has_children($id){
		$this->db->where('city_parent',$id);
		return (count($this->db->get($this->_table_name)->result()) > 0);
	}
	
	private function _dashes($n = ''){
		$out = ' ';
		for($i=0;$i<$n;$i++)$out .=' - ';
		return $out;
	}
	
	public function get_tree_citys($level=0,$max='',$parent='',$unset=FALSE){
		if($unset){
			$this->citys = array();
			$this->repeated = array();
		}
		if(empty($max))$max = $this->max_level();
		/*if($unset)
			echo "LEVEL : ".$level." & MAX : ".$max."<br>";*/
		while($level<=$max){
			$citys = $this->get_leveled($level,$parent);
			/*if($unset){
				echo $this->db->last_query()."<br>";
				dump($citys);
			}*/
			for($i=0;$i<count($citys);$i++){
				$city = $citys[$i];
				if(in_array($city->city_id,$this->repeated))continue;
				else $this->repeated[] = $city->city_id;
				if(!$this->city_has_children($city->city_id)){
					if($this->tree_citys_value == "id")
						$this->citys[''.$city->city_id] = $this->_dashes($level).$city->city_name;					
				}else{
					if($this->tree_citys_value == "id")
						$this->citys[''.$city->city_id] = $this->_dashes($level).$city->city_name;
					$this->get_tree_citys($level+1,$max,$city->city_id);
				}
			}
			$level++;
		}	
	}
}